/* FILE: inst.dsp               Copyright (c), Symmetric Research, 1998
 *
 * Example source code file for testing DSPASM instruction encoding.
 *
 * This file is NOT intended for execution, nor does it demonstrate the
 * full range of DSPASM syntax.  See the DSP32C User's manual for a complete
 * discussion of the syntax.
 *
 *
 *
 */



constant

        N         = 0x00000003,
        NDIRECT   = 0x00000A00;





main {


nops_off;


/* CAU instructions *****************************************************/

        register

                rD      = r1,
                rS      = r2,
                rT      = r3,

                rP      = r1,
                rI      = r15;



        /* Nop instruction, nop */

        nop;



        /* Call instruction, call {rH,rH+N,M} */

        call r1;

        call r1 + 0x5;

        call 0x123456;



        /* Return instruction, return (rM) */

        return;



        /* Goto instruction, goto {rH,rH+N,M} */

        goto r1;
        goto r1 + 0x5;
        goto 0x123456;



        /* Ireturn instruction, ireturn */

        ireturn;



        /* Custom opcode emit, emit( N1, N2, N3, ...) */

        emit( 0x1, 0x2);



        /* Conditional cau exp, iff ( cacond ) cau_reg_exp */

        iff ( pl ) rD = rS + rT;
        iff ( mi ) rD = rS + rT;
        iff ( ne ) rD = rS + rT;
        iff ( eq ) rD = rS + rT;
        iff ( vc ) rD = rS + rT;
        iff ( vs ) rD = rS + rT;
        iff ( cc ) rD = rS + rT;
        iff ( cs ) rD = rS + rT;
        iff ( ge ) rD = rS + rT;
        iff ( lt ) rD = rS + rT;
        iff ( gt ) rD = rS + rT;
        iff ( le ) rD = rS + rT;
        iff ( hi ) rD = rS + rT;
        iff ( ls ) rD = rS + rT;



        /* Control register store, {ioc,dauc} = N */

        ioc = 0x1;
        ioc = 0x1F;
        ioc = 0x1FF;
        ioc = 0x1FFF;
        ioc = 0x1FFFF;

        dauc = 0x1;
        dauc = 0x1F;



        /* Ioreg store, ioreg = {rS,*rP++rIr}[.size] */

        pdr = rS;
        pdr = rS.w;

        pir = rS;
        pir = rS.w;

        pcw = rS;
        pcw = rS.w;

        obuf = rS;
        obuf = rS.b;
        obuf = rS.w;
        obuf = rS.l;

        piop = rS;
        piop = rS.b;

        pdr2 = rS;
        pdr2 = rS.w;


        pdr = *rP;
        pdr = *rP.w;

        pir = *rP;
        pir = *rP.w;

        pcw = *rP;
        pcw = *rP.w;

        obuf = *rP;
        obuf = *rP.b;
        obuf = *rP.w;
        obuf = *rP.l;

        piop = *rP;
        piop = *rP.b;

        pdr2 = *rP;
        pdr2 = *rP.w;

        nop;
        nop;


        /* Memory store, {*rP++rIr,*N} = ... */

        *rP = pdr;
        *rP = pdr.w;

        *rP = pir;
        *rP = pir.w;

        *rP = pcw;
        *rP = pcw.w;

        *rP = ibuf;
        *rP = ibuf.b;
        *rP = ibuf.w;
        *rP = ibuf.l;

        *rP = piop;
        *rP = piop.b;

        *rP = pdr2;
        *rP = pdr2.w;

        *rP = rS;
        *rP = rS.b;
        *rP = rS.w;
        *rP = rS.l;

        *rP-- = rS;
        *rP-- = rS.b;
        *rP-- = rS.w;
        *rP-- = rS.l;

        *rP++ = rS;
        *rP++ = rS.b;
        *rP++ = rS.w;
        *rP++ = rS.l;

        *rP++rI = rS;
        *rP++rI = rS.b;
        *rP++rI = rS.w;
        *rP++rI = rS.l;

        *rP##rI = rS;
        *rP##rI = rS.b;
        *rP##rI = rS.w;
        *rP##rI = rS.l;

        *r20##r22 = rS;


        *NDIRECT = rS;
        *NDIRECT = rS.b;
        *NDIRECT = rS.w;
        *NDIRECT = rS.l;

        *0x100 = rS;
        *0x100 = rS.b;
        *0x100 = rS.w;
        *0x100 = rS.l;



        /* Ioreg fetch, rD = ioreg[.size] */

        rD = pdr;
        rD = pdr.w;

        rD = pir;
        rD = pir.w;

        rD = pcw;
        rD = pcw.w;

        rD = ibuf;
        rD = ibuf.b;
        rD = ibuf.w;
        rD = ibuf.l;

        rD = piop;
        rD = piop.b;

        rD = pdr2;
        rD = pdr2.w;



        /* Memory fetch, rD = {*rP++rIr,*N}[.size] */

        rD = *rP;
        rD = *rP.b;
        rD = *rP.w;
        rD = *rP.l;

        rD = *rP--;
        rD = *rP--.b;
        rD = *rP--.w;
        rD = *rP--.l;

        rD = *rP++;
        rD = *rP++.b;
        rD = *rP++.w;
        rD = *rP++.l;

        rD = *rP++rI;
        rD = *rP++rI.b;
        rD = *rP++rI.w;
        rD = *rP++rI.l;

        rD = *r20++r22;

        rD = *rP##rI;
        rD = *rP##rI.b;
        rD = *rP##rI.w;
        rD = *rP##rI.l;

        rD = *NDIRECT;
        rD = *NDIRECT.b;
        rD = *NDIRECT.w;
        rD = *NDIRECT.l;

        rD = *0x100;
        rD = *0x100.b;
        rD = *0x100.w;
        rD = *0x100.l;



        /* Register negate, rD = -rS */

        rD = -rS;



        /* PC counter operation, rD = {pc,pc+N} */

        rD = pc;
        rD = pc+N;



        /* Right sum, rD = N {+,-} rH, and immediate load, rD = N */

        rD = 0x5 + rS;
        rD = 0x5 - rD;
        rD = 0x5;



        /* Increment, decrement, rD {++,--} */

        rD++;
        rD--;



        /* Compare/and with no store, rD {-,&} {rS,N} */

        rD - rS;
        rD & rS;

        rD - N;
        rD & N;



        /* Dyadic arithmetic, rD {+=,-=,&=,|=,^=,#=,&~=} {rS,N} */

        rD += rS;
        rD -= rS;
        rD &= rS;
        rD |= rS;
        rD ^= rS;
        rD #= rS;
        rD &~= rS;

        rD += N;
        rD -= N;
        rD &= N;
        rD |= N;
        rD ^= N;
        rD #= N;
        rD &~= N;



        /* Dyadic arithmetic shift, rD {*=,/=} N */

        rD *= 8;
        rD /= 8;



        /* Dyadic logical shift, rD {>>=,>>>=,<<<=} N */

        rD >>= 3;
        rD >>>= 3;
        rD <<<= 3;



        /* Arithmetic functions, rD = rS {+,-,&,|,^,#,&~} {rT,N} */

        rD = rS + rT;
        rD = rS - rT;
        rD = rS & rT;
        rD = rS | rT;
        rD = rS ^ rT;
        rD = rS &~ rT;

        rD = rD + rS;
        rD = rD - rS;
        rD = rD & rS;
        rD = rD | rS;
        rD = rD ^ rS;
        rD = rD &~ rS;



        /* Arithmetic shift, rD = rS {*,/} N */

        rD = rS * 8;
        rD = rS / 8;



        /* Logical shift, rD = rS {>>,>>>,<<<} N */

        rD = rS >> 3;
        rD = rS >>> 3;
        rD = rS <<< 3;



        /* Register load, rD = rS */

        rD = rS;






/* DAU instructions *****************************************************/

        register

                rA      = r1,
                rB      = r2,
                rC      = r3;



        /* Full mac, [Z] = aN = [-] A {+,-} B*C */

        a0 =  a1 +  a2 *  a3;
        a0 = *rA +  a2 *  a3;
        a0 = *rA +  a2 * *rC;
        a0 =  a1 + *rB * *rC;

        *rD = a0 =  a1 +  a2 *  a3;
        *rD = a0 = *rA +  a2 *  a3;
        *rD = a0 = *rA +  a2 * *rC;
        *rD = a0 =  a1 + *rB * *rC;

        *rD = a0 =  a1 -  a2 *  a3;
        *rD = a0 = *rA -  a2 *  a3;
        *rD = a0 = *rA -  a2 * *rC;
        *rD = a0 =  a1 - *rB * *rC;

        *rD = a0 = +  a1 -  a2 *  a3;
        *rD = a0 = + *rA -  a2 *  a3;
        *rD = a0 = + *rA -  a2 * *rC;
        *rD = a0 = +  a1 - *rB * *rC;

        *rD = a0 = -  a1 -  a2 *  a3;
        *rD = a0 = - *rA -  a2 *  a3;
        *rD = a0 = - *rA -  a2 * *rC;
        *rD = a0 = -  a1 - *rB * *rC;

        *r1++r15 = a0 = a1 + *r2-- * *r3++;
        *r1++r15 = a0 = a1 + *r2++ * *r3--;

        a0 = *rA +  a2 * *rA;
        a0 =  a1 + *rB * *rB;

        *rD = a0 = *rA +  a2 * *rA;
        *rD = a0 =  a1 + *rD * *rD;



        /* [Z] = aN = [-] A {+,-} B */

        a0 =  a1 +  a2;
        a0 = *rA +  a2;
        a0 = *rA + *rB;
        a0 =  a1 + *rB;

        *rD = a0 =  a1 +  a2;
        *rD = a0 = *rA +  a2;
        *rD = a0 = *rA + *rB;
        *rD = a0 =  a1 + *rB;



        /* Tap update, [Z] = aN = [-] A {+,-} (Ztap=B)*C */

        a0 =  a1 + (*rD =  a2) *  a3;
        a0 =  a1 + (*rD = *rB) *  a3;
        a0 =  a1 + (*rD = *rB) * *rC;
        a0 =  a1 + (*rD = *rB) * *rB;

        a0 = -  a1 - (*rD =  a2) *  a3;
        a0 = -  a1 - (*rD = *rB) *  a3;
        a0 = -  a1 - (*rD = *rB) * *rC;
        a0 = -  a1 - (*rD = *rB) * *rB;



        /* [Z] = aN = [-] A*B */

        a0 =  a1 *  a2;
        a0 =  a1 * *rB;
        a0 = *rA * *rB;
        a0 = *rA * *rB;

        a0 = -  a1 *  a2;
        a0 = -  a1 * *rB;
        a0 = - *rA * *rB;
        a0 = - *rA * *rB;

        *rD = a0 =  a1 *  a2;
        *rD = a0 =  a1 * *rB;
        *rD = a0 = *rA * *rB;
        *rD = a0 = *rA * *rB;

        *rD = a0 = -  a1 *  a2;
        *rD = a0 = -  a1 * *rB;
        *rD = a0 = - *rA * *rB;
        *rD = a0 = - *rA * *rB;



        /* [Z] = aN = [-] A */

        a0 =  a1;
        a0 = *rA;

        a0 = -  a1;
        a0 = - *rA;

        *rD = a0 =  a1;
        *rD = a0 = *rA;

        *rD = a0 = -  a1;
        *rD = a0 = - *rA;



        /* Tap update, [Z] = aN = [-] (Ztap=A) {+,-,*} B */

        a0 = (*rD =  a1 ) +  a2;
        a0 = (*rD = *rA ) +  a2;
        a0 = (*rD = *rA ) + *rB;

        a0 = (*rD =  a1 ) -  a2;
        a0 = (*rD = *rA ) -  a2;
        a0 = (*rD = *rA ) - *rB;

        a0 = - (*rD =  a1 ) +  a2;
        a0 = - (*rD = *rA ) +  a2;
        a0 = - (*rD = *rA ) + *rB;

        a0 = (*rD =  a1) *  a2;
        a0 = (*rD = *rA) *  a2;
        a0 = (*rD =  a1) * *rB;

        a0 = - (*rD =  a1) *  a2;
        a0 = - (*rD = *rA) *  a2;
        a0 = - (*rD =  a1) * *rB;



        /* Special function, [Z] = aN = [-] special( A) */

        a0 =      ic( *rA);
        a0 =      oc( *rA);
        a0 =   float( *rA);
        a0 =     int( *rA);
        a0 =   round( *rA);
        a0 =   ifalt( *rA);
        a0 =   ifaeq( *rA);
        a0 =   ifagt( *rA);
        a0 = float24( *rA);
        a0 =   int24( *rA);
        a0 =    ieee( *rA);
        a0 =     dsp( *rA);
        a0 =    seed( *rA);

        *rD = a0 =      ic( *rA);
        *rD = a0 =      oc( *rA);
        *rD = a0 =   float( *rA);
        *rD = a0 =     int( *rA);
        *rD = a0 =   round( *rA);
        *rD = a0 =   ifalt( *rA);
        *rD = a0 =   ifaeq( *rA);
        *rD = a0 =   ifagt( *rA);
        *rD = a0 = float24( *rA);
        *rD = a0 =   int24( *rA);
        *rD = a0 =    ieee( *rA);
        *rD = a0 =     dsp( *rA);
        *rD = a0 =    seed( *rA);

        *rD = a0 =      ic( *rD);
        *rD = a0 =      oc( *rD);
        *rD = a0 =   float( *rD);
        *rD = a0 =     int( *rD);
        *rD = a0 =   round( *rD);
        *rD = a0 =   ifalt( *rD);
        *rD = a0 =   ifaeq( *rD);
        *rD = a0 =   ifagt( *rD);
        *rD = a0 = float24( *rD);
        *rD = a0 =   int24( *rD);
        *rD = a0 =    ieee( *rD);
        *rD = a0 =     dsp( *rD);
        *rD = a0 =    seed( *rD);



        /* Test some DAU instructions with ibuf and obuf. */

        a0 =   a1 + a2 * a3;
        a0 =   a1 + a2 * ibuf;
        a0 =   a1 + ibuf * a3;
        a0 = ibuf + a2 * a3;
        a0 =   a1 + *r1 * ibuf;

        obuf = a0 =   a1 + a2 * a3;
        obuf = a0 =   a1 + a2 * ibuf;
        obuf = a0 =   a1 + ibuf * a3;
        obuf = a0 = ibuf + a2 * a3;

        a0 = (obuf = *r1) + *r2;
        a0 = (pdr = *r1) + *r2;

        a0 = (*r1 = ibuf) + *r2;
        a0 = (*r1++r15 = ibuf) + *r2;


        *r1 = a0 = float( ibuf);
        *r1 = a0 =   int( ibuf);
        *r1 = a0 =   dsp( ibuf);
        *r1 = a0 =    ic( ibuf);
        *r1 = a0 =    oc( ibuf);



}
